"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var upgrade_exports = {};
__export(upgrade_exports, {
  upgradeAction: () => upgradeAction
});
module.exports = __toCommonJS(upgrade_exports);
var import_codesmith = require("@modern-js/codesmith");
const UPGRADE_GENERATOR = "@modern-js/upgrade-generator";
async function upgradeAction(options) {
  const { cwd = process.cwd(), debug = false, distTag, registry, needInstall } = options;
  const projectDir = cwd;
  const smith = new import_codesmith.CodeSmith({
    debug
  });
  smith.logger.debug("@modern-js/upgrade", projectDir || "", options);
  let generator = UPGRADE_GENERATOR;
  if (process.env.CODESMITH_ENV === "development") {
    generator = require.resolve(UPGRADE_GENERATOR);
  } else if (distTag) {
    generator = `${UPGRADE_GENERATOR}@${distTag}`;
  }
  try {
    await smith.forge({
      tasks: [
        {
          generator,
          config: {
            debug,
            distTag,
            registry,
            noNeedInstall: !needInstall
          }
        }
      ],
      pwd: cwd
    });
  } catch (e) {
    process.exit(1);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  upgradeAction
});
